#include <iostream>

using namespace std;

int main()
{
    long long int n,q;
    cin>>n>>q;
    long long int nap[n+1];
    long long int mennyi[n+1];
    long long int osszeg=0;

    for(int i=1; i<=n; i++)
    {
        cin>>nap[i]>>mennyi[i];
        osszeg+=mennyi[i];
    }

    long long int meddig[q+1];

    for(int i=1; i<=q; i++)
    {
        cin>>meddig[i];
    }

    long long int kekszek=0;
    long long int megevett=0;
    long long int szamlalo=1;
    for(int i=1; i<=q; i++)
    {

        if(meddig[i]>=osszeg)
        {
            cout<<osszeg<<endl;
        }
        else
        {

            for(int j=1; j<=meddig[i]; j++)
            {
                if(j==nap[szamlalo])
                {
                    kekszek+=mennyi[szamlalo];
                    szamlalo++;
                }
                if(kekszek>0)
                {
                    megevett++;
                    kekszek--;
                }
            }
            cout<<megevett<<endl;
            megevett=0;
            szamlalo=1;
            kekszek=0;
        }
    }
    return 0;
}